org.apache.ignite.spi.swapspace.noop

## Class NoopSwapSpaceSpi

- java.lang.Object
- - org.apache.ignite.spi.IgniteSpiAdapter
  - - org.apache.ignite.spi.swapspace.noop.NoopSwapSpaceSpi

All Implemented Interfaces:
  IgniteSpi, IgniteSpiManagementMBean, SwapSpaceSpi

    @IgniteSpiNoop
    @IgniteSpiMultipleInstancesSupport(value=true)
    public class NoopSwapSpaceSpi
    extends IgniteSpiAdapter
    implements SwapSpaceSpi

No-op implementation of `SwapSpaceSpi`. Exists for testing and benchmarking purposes.

### Field Summary

### Fields inherited from class org.apache.ignite.spi.IgniteSpiAdapter

`gridName, ignite, nodeId`

### Constructor Summary

Constructors
Constructor and Description
`NoopSwapSpaceSpi()`

### Method Summary

Methods
`void` `clear(String space)` Entirely clears data space with given name, if any.
`long` `count(String space)` Gets number of stored entries (keys) in data space with given name.
`long` `count(String spaceName, Set<Integer> parts)` Gets number of stored entries (keys) in data space with given name.
`<K> IgniteSpiCloseableIterator<K>` `keyIterator(String spaceName, SwapContext ctx)` Gets iterator over space keys.
`Collection<Integer>` `partitions(String spaceName)` Gets partitions IDs that are stored in the passed in space.
`IgniteSpiCloseableIterator<Map.Entry<byte[],byte[]>>` `rawIterator(String spaceName)` Gets raw iterator over space entries.
`IgniteSpiCloseableIterator<Map.Entry<byte[],byte[]>>` `rawIterator(String spaceName, int part)` Gets raw iterator over space entries.
`byte[]` `read(String spaceName, SwapKey key, SwapContext ctx)` Reads stored value as array of bytes by key from data space with given name.
`Map<SwapKey,byte[]>` `readAll(String spaceName, Iterable<SwapKey> keys, SwapContext ctx)` Reads stored values as array of bytes by all passed keys from data space with given name.
`void` `remove(String spaceName, SwapKey key, IgniteInClosure<byte[]> c, SwapContext ctx)` Removes value stored in data space with given name corresponding to specified key.
`void` `removeAll(String spaceName, Collection<SwapKey> keys, IgniteBiInClosure<SwapKey,byte[]> c, SwapContext ctx)` Removes values stored in data space with given name corresponding to specified keys.
`void` `setListener(SwapSpaceSpiListener evictLsnr)` Sets eviction listener to receive notifications on evicted swap entries.
`long` `size(String space)` Gets size in bytes for data space with given name.
`void` `spiStart(String gridName)` This method is called to start SPI.
`void` `spiStop()` This method is called to stop SPI.
`void` `store(String spaceName, SwapKey key, byte[] val, SwapContext ctx)` Stores value as array of bytes with given key into data space with given name.
`void` `storeAll(String spaceName, Map<SwapKey,byte[]> pairs, SwapContext ctx)` Stores key-value pairs (both keys and values are arrays of bytes) into data space with given name.
`String` `toString()`

### Methods inherited from class org.apache.ignite.spi.IgniteSpiAdapter

`addTimeoutObject, assertParameter, checkConfigurationConsistency0, configInfo, createSpiAttributeName, getConsistentAttributeNames, getExceptionRegistry, getIgniteHome, getLocalNodeId, getName, getNodeAttributes, getSpiContext, getStartTimestamp, getStartTimestampFormatted, getUpTime, getUpTimeFormatted, injectables, injectResources, isNodeStopping, onContextDestroyed, onContextDestroyed0, onContextInitialized, onContextInitialized0, registerMBean, removeTimeoutObject, setName, startInfo, startStopwatch, stopInfo, unregisterMBean`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.apache.ignite.spi.IgniteSpi

`getName, getNodeAttributes, onContextDestroyed, onContextInitialized`

### Constructor Detail

#### NoopSwapSpaceSpi

    public NoopSwapSpaceSpi()

### Method Detail

#### spiStart

    public void spiStart(@Nullable
                String gridName)
                  throws IgniteSpiException

This method is called to start SPI. After this method returns successfully kernel assumes that SPI is fully operational.

Specified by:
  `spiStart` in interface `IgniteSpi`
Parameters:
  `gridName` - Name of grid instance this SPI is being started for (`null` for default grid).
Throws:
  `IgniteSpiException` - Throws in case of any error during SPI start.

#### spiStop

    public void spiStop()
                 throws IgniteSpiException

This method is called to stop SPI. After this method returns kernel assumes that this SPI is finished and all resources acquired by it are released.

Note that this method can be called at any point including during recovery of failed start. It should make no assumptions on what state SPI will be in when this method is called.

Specified by:
  `spiStop` in interface `IgniteSpi`
Throws:
  `IgniteSpiException` - Thrown in case of any error during SPI stop.

#### clear

    public void clear(@Nullable
             String space)
               throws IgniteSpiException

Entirely clears data space with given name, if any.

Specified by:
  `clear` in interface `SwapSpaceSpi`
Parameters:
  `space` - Space name to clear.
Throws:
  `IgniteSpiException` - In case of any errors.

#### size

    public long size(@Nullable
            String space)
              throws IgniteSpiException

Gets size in bytes for data space with given name. If specified space does not exist this method returns `0`.

Specified by:
  `size` in interface `SwapSpaceSpi`
Parameters:
  `space` - Space name to get size for.
Returns:
  Size in bytes.
Throws:
  `IgniteSpiException` - In case of any errors.

#### count

    public long count(@Nullable
             String space)
               throws IgniteSpiException

Gets number of stored entries (keys) in data space with given name. If specified space does not exist this method returns `0`.

Specified by:
  `count` in interface `SwapSpaceSpi`
Parameters:
  `space` - Space name to get number of entries for.
Returns:
  Number of stored entries in specified space.
Throws:
  `IgniteSpiException` - In case of any errors.

#### count

    public long count(@Nullable
             String spaceName,
             Set<Integer> parts)
               throws IgniteSpiException

Gets number of stored entries (keys) in data space with given name. If specified space does not exist this method returns `0`.

Specified by:
  `count` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name to get number of entries for.
  `parts` - Partitions.
Returns:
  Number of stored entries in specified space.
Throws:
  `IgniteSpiException` - In case of any errors.

#### read

    @Nullable
    public byte[] read(@Nullable
                       String spaceName,
                       SwapKey key,
                       SwapContext ctx)
                throws IgniteSpiException

Reads stored value as array of bytes by key from data space with given name. If specified space does not exist this method returns `null`.

Specified by:
  `read` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Name of the data space to read from.
  `key` - Key used to read value from data space.
  `ctx` - Swap context.
Returns:
  Value as array of bytes stored in specified data space that matches to given key.
Throws:
  `IgniteSpiException` - In case of any errors.

#### readAll

    public Map<SwapKey,byte[]> readAll(@Nullable
                              String spaceName,
                              Iterable<SwapKey> keys,
                              SwapContext ctx)
                                throws IgniteSpiException

Reads stored values as array of bytes by all passed keys from data space with given name. If specified space does not exist this method returns empty map.

Specified by:
  `readAll` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Name of the data space to read from.
  `keys` - Keys used to read values from data space.
  `ctx` - Swap context.
Returns:
  Map in which keys are the ones passed into method and values are corresponding values read from swap storage.
Throws:
  `IgniteSpiException` - In case of any errors.

#### remove

    public void remove(@Nullable
              String spaceName,
              SwapKey key,
              @Nullable
              IgniteInClosure<byte[]> c,
              SwapContext ctx)
                throws IgniteSpiException

Removes value stored in data space with given name corresponding to specified key.

Specified by:
  `remove` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name to remove value from.
  `key` - Key to remove value in the specified space for.
  `c` - Optional closure that takes removed value and executes after actual removing. If there was no value in storage the closure is not executed.
  `ctx` - Swap context.
Throws:
  `IgniteSpiException` - In case of any errors.

#### removeAll

    public void removeAll(@Nullable
                 String spaceName,
                 Collection<SwapKey> keys,
                 @Nullable
                 IgniteBiInClosure<SwapKey,byte[]> c,
                 SwapContext ctx)
                   throws IgniteSpiException

Removes values stored in data space with given name corresponding to specified keys.

Specified by:
  `removeAll` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name to remove values from.
  `keys` - Keys to remove value in the specified space for.
  `c` - Optional closure that takes removed value and executes after actual removing. If there was no value in storage the closure is not executed.
  `ctx` - Swap context.
Throws:
  `IgniteSpiException` - In case of any errors.

#### store

    public void store(@Nullable
             String spaceName,
             SwapKey key,
             @Nullable
             byte[] val,
             SwapContext ctx)
               throws IgniteSpiException

Stores value as array of bytes with given key into data space with given name.

Specified by:
  `store` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name to store key-value pair into.
  `key` - Key to store given value for. This key can be used further to read or remove stored value.
  `val` - Some value as array of bytes to store into specified data space.
  `ctx` - Swap context.
Throws:
  `IgniteSpiException` - In case of any errors.

#### storeAll

    public void storeAll(@Nullable
                String spaceName,
                Map<SwapKey,byte[]> pairs,
                SwapContext ctx)
                  throws IgniteSpiException

Stores key-value pairs (both keys and values are arrays of bytes) into data space with given name.

Specified by:
  `storeAll` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name to store key-value pairs into.
  `pairs` - Map of stored key-value pairs where each one is an array of bytes.
  `ctx` - Swap context.
Throws:
  `IgniteSpiException` - In case of any errors.

#### setListener

    public void setListener(@Nullable
                   SwapSpaceSpiListener evictLsnr)

Sets eviction listener to receive notifications on evicted swap entries.

Specified by:
  `setListener` in interface `SwapSpaceSpi`
Parameters:
  `evictLsnr` - Eviction listener (`null` to stop receiving notifications).

#### partitions

    public Collection<Integer> partitions(@Nullable
                                 String spaceName)
                                   throws IgniteSpiException

Gets partitions IDs that are stored in the passed in space.

Specified by:
  `partitions` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name.
Returns:
  Partitions IDs or `null` if space is unknown.
Throws:
  `IgniteSpiException` - If failed.

#### keyIterator

    public <K> IgniteSpiCloseableIterator<K> keyIterator(@Nullable
                                                String spaceName,
                                                SwapContext ctx)
                                              throws IgniteSpiException

Gets iterator over space keys.

Specified by:
  `keyIterator` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name.
  `ctx` - Swap context.
Returns:
  Iterator over space entries or `null` if space is unknown.
Throws:
  `IgniteSpiException` - If failed.

#### rawIterator

    public IgniteSpiCloseableIterator<Map.Entry<byte[],byte[]>> rawIterator(@Nullable
                                                                   String spaceName)
                                                                     throws IgniteSpiException

Gets raw iterator over space entries.

Specified by:
  `rawIterator` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name.
Returns:
  Iterator over space entries or `null` if space is unknown.
Throws:
  `IgniteSpiException` - If failed.

#### rawIterator

    public IgniteSpiCloseableIterator<Map.Entry<byte[],byte[]>> rawIterator(@Nullable
                                                                   String spaceName,
                                                                   int part)
                                                                     throws IgniteSpiException

Gets raw iterator over space entries.

Specified by:
  `rawIterator` in interface `SwapSpaceSpi`
Parameters:
  `spaceName` - Space name.
  `part` - Partition.
Returns:
  Iterator over space entries or `null` if space is unknown.
Throws:
  `IgniteSpiException` - If failed.

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.2.0-incubating
Release Date | : June 16 2015